#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "topology_var.h"

int main(int argc, char *argv[]) 
{

  int i;
  if (argc < 6) {
    printf("  ./a.out torus Num_Dimension Num_Terminals_Per_Switch \
    a1 a2 ... an bw0 bw1 bw2... bwn DIMORDER\n");
    exit(0);
  }
 if (strcmp(argv[1], "torus") == 0){
    if( torus_read_input(argc, argv) != 0 )exit(0);
    nprocs = totPE;
    while (1) {
      int src, dst;
      Path p;

      printf("input source_id and destination_id : ");
      fflush(0);
      scanf("%d %d", &src, &dst);
      getchar();
      if ((src >=0) && (src <nprocs) &&
          (dst >=0) && (dst <nprocs)) {
	torus_dimorder_routing(src, dst, p);
	torus_print_path(p);
      } else {
	if (src == -1) exit(0);
        else {
	  printf("src %d or dst %d out of bound 0..%d\n", src, dst, nprocs-1);
	}
      }
    } 
  }else{
    printf("Error : Topology is not supported.\n\n");
    printf("Currently supported topologies are:\n");
    printf("Torus Topology : torus\n");
    exit(0);
  }
			     
  return 0;
}


